#!/usr/bin/perl -w -I/usr/sausalito/perl
# $Id: vhost_addrem.pl,v 1.6.2.2 2002/04/05 02:26:26 pbaltz Exp $
# Copyright 2000-2002 Sun Microsystems, Inc., All rights reserved.
#
# add or remove the include line for a vhost when creating or destroying,
#

use CCE;
use Sauce::Util;
use Base::Httpd qw(httpd_add_include httpd_remove_include);
use Sauce::Service;

my $cce = new CCE;

$cce->connectfd();

my ($ok, $vhost);
my $vhost_new = $cce->event_new();
if ($cce->event_is_create()) { 
	$vhost = $cce->event_object();
	Sauce::Util::addrollbackcommand("/etc/rc.d/init.d/httpd restart >/dev/null 2>&1 &");
	$ok = httpd_add_include("$Base::Httpd::vhost_dir/$vhost->{name}");

} elsif ($cce->event_is_destroy()) { 
	$vhost = $cce->event_old();
	Sauce::Util::addrollbackcommand("/etc/rc.d/init.d/httpd restart >/dev/null 2>&1 &");
	$ok = httpd_remove_include("$Base::Httpd::vhost_dir/$vhost->{name}");
	# don't remove the file here to avoid a race condition
}

if (not $ok) {
	$cce->bye('FAIL', '[[base-apache.cantEditHttpdConf]]');
	exit(1);
}

# always register a reload, to make sure apache knows the file is gone
service_run_init('httpd', 'reload');

$cce->bye('SUCCESS');
exit(0);
