#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: vhost_suspend.pl,v 1.1.2.3 2002/02/28 01:53:32 pbaltz Exp $
# Copyright 2002 Sun Microsystems, Inc.  All rights reserved.
#
# Setup rewrite rules when disabling a VirtualHost to give a 403 error, since
# we don't want people bounced to the login page anymore.
#

use CCE;
use Sauce::Util;
use Base::Httpd qw(httpd_get_vhost_conf_file);

my $cce = new CCE;
$cce->connectfd();

my $vhost = $cce->event_object();

# rewrite the rewrite rules if site is enabled/disabled
my $ok = 1;
my $conf_file = httpd_get_vhost_conf_file($vhost->{name});
if (!$vhost->{enabled}) {
	$ok = Sauce::Util::editfile($conf_file, *rewrite_rules, 1, $vhost);
} elsif (!$cce->event_is_create()) {
	$ok = Sauce::Util::editfile($conf_file, *rewrite_rules, 0, $vhost);
}

if (!$ok) {
	$cce->bye('FAIL', '[[base-apache.cantEditVhost]]');
	exit(1);
}

$cce->bye('SUCCESS');
exit(0);

sub rewrite_rules
{
	my ($in, $out, $add, $vhost) = @_;

	while (my $line = <$in>) {
		if ($add && ($line =~ /^RewriteEngine\s+on\s*$/)) {
			print $out $line;
			print $out <<NEWRULES;
# BEGIN VHOST SUSPEND RULES
RewriteCond %{REQUEST_URI}		/error/.*
RewriteRule .*				- [L]
RewriteCond %{REQUEST_URI}              /libImage/.*
RewriteRule .*                          - [L]
RewriteCond %{HTTP_HOST}		^$vhost->{ipaddr}(:80)?\$ [OR]
RewriteCond %{HTTP_HOST}		^$vhost->{fqdn}(:80)?\$ [NC]
RewriteRule .*				- [L,F]
# END VHOST SUSPEND RULES
NEWRULES

		} elsif (!$add && ($line =~ /^# BEGIN VHOST SUSPEND RULES$/)) {
			# remove suspend rewrite rules
			while (my $trash = <$in>) {
				if ($trash =~ /^# END VHOST SUSPEND RULES$/) {
					last;
				}
			}
		} else {
			# some other line, just print it out
			print $out $line;
		}
	}

	return 1;
}
